Index: /branches/0.3-poznan-univ/source/Lib/TLibCommon/TComMP.h
===================================================================
--- /branches/0.3-poznan-univ/source/Lib/TLibCommon/TComMP.h	(revision 28)
+++ /branches/0.3-poznan-univ/source/Lib/TLibCommon/TComMP.h	(revision 28)
@@ -0,0 +1,201 @@
+
+
+#ifndef __TCOMMP__
+#define __TCOMMP__
+
+class TComMP;
+
+#include "../TLibCommon/TypeDef.h"
+#include "../TLibCommon/CommonDef.h"
+
+#if POZNAN_MP_USE_DEPTH_MAP_GENERATION
+class TComDepthMapGenerator;
+//#include "../TLibCommon/TComDepthMapGenerator.h"
+#else
+class TAppComCamPara;
+//#include "../../App/TAppCommon/TAppComCamPara.h"
+#endif
+
+#include "../TLibCommon/TComList.h"
+#include "../TLibCommon/TComSlice.h"
+#include "../TLibCommon/TComPic.h"
+#include "../TLibCommon/TComDataCU.h"
+#include "../TLibCommon/TComMotionInfo.h"
+
+#include <map>
+//#include <cstdlib>
+//using namespace std;
+
+#if POZNAN_MP
+
+// ====================================================================================================================
+// Class definition
+// ====================================================================================================================
+
+
+/// MP class
+class TComMP
+{
+//typedef Int PUT_MP_ARRAY_TYPE;
+typedef Short PUT_MP_ARRAY_TYPE;
+typedef std::map<UInt,PUT_MP_ARRAY_TYPE**> TComMapppi;
+
+static const int OCCLUSION = -1;
+
+private:
+
+  Bool m_bInit;
+  Bool m_bEnabled;
+  Bool m_bDBMPEnabled;
+
+  UInt m_uiHeight;
+  UInt m_uiWidth;
+
+  UInt m_uiPOC;
+  UInt m_uiView;
+  Bool m_bIsDepth;
+
+#if POZNAN_MP_USE_DEPTH_MAP_GENERATION
+  TComDepthMapGenerator* m_pcDepthMapGenerator;
+#else
+  //TAppComCamPara* m_pcCameraData;
+  Int**** m_aiBaseViewShiftLUT;
+#endif
+  std::vector<TComPic*>* m_pcRefPicsList;
+  std::vector<TComPic*>* m_pcDepthRefPicsList;
+
+  Short** m_ppiMvPtCorrX;
+  Short** m_ppiMvPtCorrY;
+  Short** m_ppiMvPtCorrZ;
+  Short** m_ppiMvPtCorrRefViewIdx;
+
+  TComDataCU*** m_pppcRefCU; //XY array of pointers to reference CU for each point of picture
+  UShort** m_ppuicRefPartAddr; //XY array of part addresses for each reference CU for each point of picture
+
+#if POZNAN_DBMP & !POZNAN_DBMP_COMPRESS_ME_DATA
+  TComMapppi m_ppiL0RefPOC;
+  TComMapppi m_ppiL0MvX;
+  TComMapppi m_ppiL0MvY;
+  TComMapppi m_ppiL1RefPOC;
+  TComMapppi m_ppiL1MvX;
+  TComMapppi m_ppiL1MvY;
+#endif
+
+#if POZNAN_DBMP_CALC_PRED_DATA
+  Int* m_piTempL0RefIdx;
+  Int* m_piTempL0MvX;
+  Int* m_piTempL0MvY;
+  Int* m_piTempL1RefIdx;
+  Int* m_piTempL1MvX;
+  Int* m_piTempL1MvY;
+
+  Int*	m_piTempBuff;
+  Int*	m_piResBuff;
+#endif
+
+#if POZNAN_DBMP_CALC_PRED_DATA
+  TComCUMvField* apcDBMPPredMVField[2];
+#endif
+
+#if POZNAN_DBMP & !POZNAN_DBMP_COMPRESS_ME_DATA
+  Void initArrayMap(UInt uiViewId, Bool bIsDepth);
+#endif
+
+public:
+
+#if POZNAN_MP_USE_DEPTH_MAP_GENERATION
+  TComMP(UInt uiHeight=0, UInt uiWidth=0);
+#else
+  //TComMP(UInt uiHeight=0, UInt uiWidth=0, TAppComCamPara* pcCameraData=NULL);
+  TComMP(UInt uiHeight=0, UInt uiWidth=0, Int**** aiBaseViewShiftLUT=NULL);
+#endif
+  ~TComMP();
+
+#if POZNAN_MP_USE_DEPTH_MAP_GENERATION
+  Void			init(UInt uiHeight, UInt uiWidth);
+#else
+  //Void			init(UInt uiHeight, UInt uiWidth, TAppComCamPara* pcCameraData);
+  Void			init(UInt uiHeight, UInt uiWidth, Int**** aiBaseViewShiftLUT);
+#endif
+  Void			uninit();
+  Void			clear();
+  Void			disable();
+
+  Bool			isInit();
+  Bool			isEnabled();
+  Bool			isDBMPEnabled();
+
+#if POZNAN_MP_USE_DEPTH_MAP_GENERATION
+  Void			setDepthMapGenerator(TComDepthMapGenerator*  pcDepthMapGenerator){m_pcDepthMapGenerator = pcDepthMapGenerator;}
+#endif  
+  Void			setRefPicsList(std::vector<TComPic*>* pcListPic){m_pcRefPicsList = pcListPic;}
+  Void			setDepthRefPicsList(std::vector<TComPic*>* pcListPic){m_pcDepthRefPicsList = pcListPic;}
+  Bool			pairMultiview(TComPic* pcPic);
+
+  Short**		getMPCx() {return m_ppiMvPtCorrX;}
+  Short**		getMPCy() {return m_ppiMvPtCorrY;}
+  Short**		getMPCz() {return m_ppiMvPtCorrZ;}
+  Short**		getMPCRefViewIdx() {return m_ppiMvPtCorrRefViewIdx;}
+  TComDataCU***	getMPCRefCU() {return m_pppcRefCU;}
+  UShort**		getMPCRefPartAddr() {return m_ppuicRefPartAddr;}
+
+#if POZNAN_MP_FILL
+  Void			fillMultiview(UInt uiViewId);
+#endif
+
+#if POZNAN_DBMP
+#if !POZNAN_DBMP_COMPRESS_ME_DATA
+  PUT_MP_ARRAY_TYPE**			getL0RefPOC(UInt uiViewID, Bool bIsDepth) {return m_ppiL0RefPOC[(bIsDepth)? (uiViewID+MAX_NUMBER_VIEWS) : uiViewID];}
+  PUT_MP_ARRAY_TYPE**			getL0MvX(UInt uiViewID, Bool bIsDepth) {return m_ppiL0MvX[(bIsDepth)? (uiViewID+MAX_NUMBER_VIEWS) : uiViewID];}
+  PUT_MP_ARRAY_TYPE**			getL0MvY(UInt uiViewID, Bool bIsDepth) {return m_ppiL0MvY[(bIsDepth)? (uiViewID+MAX_NUMBER_VIEWS) : uiViewID];}
+  PUT_MP_ARRAY_TYPE**			getL1RefPOC(UInt uiViewID, Bool bIsDepth) {return m_ppiL1RefPOC[(bIsDepth)? (uiViewID+MAX_NUMBER_VIEWS) : uiViewID];}
+  PUT_MP_ARRAY_TYPE**			getL1MvX(UInt uiViewID, Bool bIsDepth) {return m_ppiL1MvX[(bIsDepth)? (uiViewID+MAX_NUMBER_VIEWS) : uiViewID];}
+  PUT_MP_ARRAY_TYPE**			getL1MvY(UInt uiViewID, Bool bIsDepth) {return m_ppiL1MvY[(bIsDepth)? (uiViewID+MAX_NUMBER_VIEWS) : uiViewID];}
+
+  Void			setL0RefPOC(UInt uiViewID, Bool bIsDepth, UInt uiX, UInt uiY, PUT_MP_ARRAY_TYPE iVal) {m_ppiL0RefPOC[(bIsDepth)? (uiViewID+MAX_NUMBER_VIEWS) : uiViewID][uiY][uiX]=iVal;}
+  Void			setL0MvX(UInt uiViewID, Bool bIsDepth, UInt uiX, UInt uiY, PUT_MP_ARRAY_TYPE iVal) {m_ppiL0MvX[(bIsDepth)? (uiViewID+MAX_NUMBER_VIEWS) : uiViewID][uiY][uiX]=iVal;}
+  Void			setL0MvY(UInt uiViewID, Bool bIsDepth, UInt uiX, UInt uiY, PUT_MP_ARRAY_TYPE iVal) {m_ppiL0MvY[(bIsDepth)? (uiViewID+MAX_NUMBER_VIEWS) : uiViewID][uiY][uiX]=iVal;}
+  Void			setL1RefPOC(UInt uiViewID, Bool bIsDepth, UInt uiX, UInt uiY, PUT_MP_ARRAY_TYPE iVal) {m_ppiL1RefPOC[(bIsDepth)? (uiViewID+MAX_NUMBER_VIEWS) : uiViewID][uiY][uiX]=iVal;}
+  Void			setL1MvX(UInt uiViewID, Bool bIsDepth, UInt uiX, UInt uiY, PUT_MP_ARRAY_TYPE iVal) {m_ppiL1MvX[(bIsDepth)? (uiViewID+MAX_NUMBER_VIEWS) : uiViewID][uiY][uiX]=iVal;}
+  Void			setL1MvY(UInt uiViewID, Bool bIsDepth, UInt uiX, UInt uiY, PUT_MP_ARRAY_TYPE iVal) {m_ppiL1MvY[(bIsDepth)? (uiViewID+MAX_NUMBER_VIEWS) : uiViewID][uiY][uiX]=iVal;}
+
+  Void saveDBMPData(TComDataCU* pcCU);
+#endif
+
+  inline Void getDBMPPredData(TComDataCU* pcCU, Int x, Int y, 
+							  Int &ref_frame0, Int &ref_frame0_idx, TComMv &mv0, Int ref_frame0_idx_2nd, TComMv mv0_2nd,
+							  Int &ref_frame1, Int &ref_frame1_idx, TComMv &mv1, Int ref_frame1_idx_2nd, TComMv mv1_2nd);
+#endif
+
+#if POZNAN_DBMP_CALC_PRED_DATA
+  Int*			getTempL0RefIdx() {return m_piTempL0RefIdx;}
+  Int*			getTempL0MvX() {return m_piTempL0MvX;}
+  Int*			getTempL0MvY() {return m_piTempL0MvY;}
+  Int*			getTempL1RefIdx() {return m_piTempL1RefIdx;}
+  Int*			getTempL1MvX() {return m_piTempL1MvX;}
+  Int*			getTempL1MvY() {return m_piTempL1MvY;}
+  
+  inline Void xCalcDBMPPredData(UInt uiCnt, Int &ref_frame0_idx, TComMv &mv0, Int &ref_frame1_idx, TComMv &mv1);
+#endif
+
+#if POZNAN_DBMP_CALC_PRED_DATA
+  Void calcDBMPPredData(TComDataCU* pcCU, UInt uiAbsPartIdx, Int &ref_frame0_idx,  TComMv &mv0, Int &ref_frame1_idx,  TComMv &mv1);
+  TComCUMvField* getDBMPPredMVField(RefPicList eRefListIdx){return apcDBMPPredMVField[eRefListIdx];}
+  Void setDBMPPredMVField(RefPicList eRefListIdx, TComDataCU* pcCU);
+  Void setDBMPPredMVField(RefPicList eRefListIdx, TComDataCU* pcCU, Int iNumPartSrc, Int iPartAddrDst);
+#endif
+
+  TComPic*		GetPicFromList(std::vector<TComPic*>* rcListPic, UInt uiPOC, UInt uiView);
+  Int			GetRepresentativeVal(UInt &uiCntMax, Int* puiIn, UInt uiLen, Int* puiTemp, Bool bUseRestrictedVal=false, Int uiRestrictedVal=0);
+
+};
+
+
+
+
+//#endif
+
+#endif // __TCOMMP__
+
+
+#endif // POZNAN_MP
Index: /branches/0.3-poznan-univ/source/Lib/TLibCommon/TComPic.cpp
===================================================================
--- /branches/0.3-poznan-univ/source/Lib/TLibCommon/TComPic.cpp	(revision 27)
+++ /branches/0.3-poznan-univ/source/Lib/TLibCommon/TComPic.cpp	(revision 28)
@@ -50,4 +50,13 @@
   m_apcPicYuv[0]      = NULL;
   m_apcPicYuv[1]      = NULL;
+#if POZNAN_AVAIL_MAP
+  m_apcPicYuvAvail     = NULL;
+#endif
+#if POZNAN_SYNTH_VIEW
+  m_apcPicYuvSynth     = NULL;
+#endif
+#if POZNAN_TEXTURE_TU_DELTA_QP_ACCORDING_TO_DEPTH
+  m_apcPicYuvSynthDepth= NULL; 
+#endif
 #if DEPTH_MAP_GENERATION
   m_pcPredDepthMap    = NULL;
@@ -118,4 +127,29 @@
     m_apcPicYuv[1]  = NULL;
   }
+#if POZNAN_AVAIL_MAP
+  if (m_apcPicYuvAvail)
+  {
+    m_apcPicYuvAvail->destroy();
+    delete m_apcPicYuvAvail;
+    m_apcPicYuvAvail  = NULL;
+  }
+#endif
+
+#if POZNAN_SYNTH_VIEW
+  if (m_apcPicYuvSynth)
+  {
+    m_apcPicYuvSynth->destroy();
+    delete m_apcPicYuvSynth;
+    m_apcPicYuvSynth  = NULL;
+  }
+#endif
+#if POZNAN_TEXTURE_TU_DELTA_QP_ACCORDING_TO_DEPTH
+  if (m_apcPicYuvSynthDepth)
+  {
+    m_apcPicYuvSynthDepth->destroy();
+    delete m_apcPicYuvSynthDepth;
+    m_apcPicYuvSynthDepth  = NULL;
+  }
+#endif
   
 #if DEPTH_MAP_GENERATION
@@ -195,4 +229,52 @@
 }
 
+#if POZNAN_AVAIL_MAP
+Void
+TComPic::addAvailabilityBuffer()
+{
+  AOT( m_apcPicYuvAvail );
+  AOF( m_apcPicYuv[1] );
+  Int   iWidth        = m_apcPicYuv[1]->getWidth      ();
+  Int   iHeight       = m_apcPicYuv[1]->getHeight     ();
+  UInt  uiMaxCuWidth  = m_apcPicYuv[1]->getMaxCuWidth ();
+  UInt  uiMaxCuHeight = m_apcPicYuv[1]->getMaxCuHeight();
+  UInt  uiMaxCuDepth  = m_apcPicYuv[1]->getMaxCuDepth ();
+  m_apcPicYuvAvail      = new TComPicYuv;
+  m_apcPicYuvAvail      ->create( iWidth, iHeight, uiMaxCuWidth, uiMaxCuHeight, uiMaxCuDepth );
+}
+#endif
+
+#if POZNAN_SYNTH_VIEW
+Void
+TComPic::addSynthesisBuffer()
+{
+  AOT( m_apcPicYuvSynth );
+  AOF( m_apcPicYuv[1] );
+  Int   iWidth        = m_apcPicYuv[1]->getWidth      ();
+  Int   iHeight       = m_apcPicYuv[1]->getHeight     ();
+  UInt  uiMaxCuWidth  = m_apcPicYuv[1]->getMaxCuWidth ();
+  UInt  uiMaxCuHeight = m_apcPicYuv[1]->getMaxCuHeight();
+  UInt  uiMaxCuDepth  = m_apcPicYuv[1]->getMaxCuDepth ();
+  m_apcPicYuvSynth      = new TComPicYuv;
+  m_apcPicYuvSynth      ->create( iWidth, iHeight, uiMaxCuWidth, uiMaxCuHeight, uiMaxCuDepth );
+}
+#endif
+
+#if POZNAN_TEXTURE_TU_DELTA_QP_ACCORDING_TO_DEPTH
+Void
+TComPic::addSynthesisDepthBuffer()
+{
+  AOT( m_apcPicYuvSynthDepth );
+  AOF( m_apcPicYuv[1] );
+  Int   iWidth        = m_apcPicYuv[1]->getWidth      ();
+  Int   iHeight       = m_apcPicYuv[1]->getHeight     ();
+  UInt  uiMaxCuWidth  = m_apcPicYuv[1]->getMaxCuWidth ();
+  UInt  uiMaxCuHeight = m_apcPicYuv[1]->getMaxCuHeight();
+  UInt  uiMaxCuDepth  = m_apcPicYuv[1]->getMaxCuDepth ();
+  m_apcPicYuvSynthDepth      = new TComPicYuv;
+  m_apcPicYuvSynthDepth      ->create( iWidth, iHeight, uiMaxCuWidth, uiMaxCuHeight, uiMaxCuDepth );
+}
+#endif
+
 #if PARALLEL_MERGED_DEBLK
 Void
@@ -286,4 +368,43 @@
 }
 
+#if POZNAN_AVAIL_MAP
+Void
+TComPic::removeAvailabilityBuffer()
+{
+  if( m_apcPicYuvAvail )
+  {
+    m_apcPicYuvAvail->destroy();
+    delete m_apcPicYuvAvail;
+    m_apcPicYuvAvail  = NULL;
+  }
+}
+#endif
+
+#if POZNAN_SYNTH_VIEW
+Void
+TComPic::removeSynthesisBuffer()
+{
+  if( m_apcPicYuvSynth )
+  {
+    m_apcPicYuvSynth->destroy();
+    delete m_apcPicYuvSynth;
+    m_apcPicYuvSynth  = NULL;
+  }
+}
+#endif
+
+#if POZNAN_TEXTURE_TU_DELTA_QP_ACCORDING_TO_DEPTH
+Void
+TComPic::removeSynthesisDepthBuffer()
+{
+  if( m_apcPicYuvSynthDepth )
+  {
+    m_apcPicYuvSynthDepth->destroy();
+    delete m_apcPicYuvSynthDepth;
+    m_apcPicYuvSynthDepth  = NULL;
+  }
+}
+#endif
+
 #if PARALLEL_MERGED_DEBLK
 Void
@@ -351,2 +472,58 @@
 #endif
 
+#if POZNAN_AVAIL_MAP
+Void TComPic::checkSynthesisAvailability( TComDataCU*& rpcCU, UInt iCuAddr, UInt uiAbsZorderIdx, UInt uiPartDepth, Bool *&rpbCUSynthesied )
+{ 
+  rpbCUSynthesied[0] = true;
+  rpbCUSynthesied[1] = true;
+  rpbCUSynthesied[2] = true;
+  rpbCUSynthesied[3] = true;
+
+  if (!getPicYuvAvail())
+  {
+    rpbCUSynthesied[0] = false;
+    rpbCUSynthesied[1] = false;
+    rpbCUSynthesied[2] = false;
+    rpbCUSynthesied[3] = false;
+    return;    
+  }
+  
+  Int x, y;
+  Bool bAvailable = true;
+  Pel* pAvail  = getPicYuvAvail()->getLumaAddr ( iCuAddr, uiAbsZorderIdx );
+  Int CUHeight = g_uiMaxCUHeight >> uiPartDepth; //rpcCU->getHeight(uiAbsZorderIdx);
+  Int CUWidth  = g_uiMaxCUWidth  >> uiPartDepth; //rpcCU->getWidth(uiAbsZorderIdx);
+  
+  Int  iStride  = getPicYuvAvail()->getStride();
+  for ( y = ((CUHeight - 1) >> 1); y >= 0; y-- )
+  {
+    for ( x = ((CUWidth - 1) >> 1); x >= 0; x-- )
+    {
+      rpbCUSynthesied[0] &= (pAvail[x] != 0);
+    }
+    for ( x = CUWidth - 1; x >= ((CUWidth) >> 1); x-- )
+    {
+      rpbCUSynthesied[1] &= (pAvail[x] != 0);
+    }
+    pAvail += iStride;
+  }
+  //for ( y = CUHeight - 1; y >= ((CUHeight) >> 1); y-- )
+  for ( y = ((CUHeight - 1) >> 1); y >= 0; y-- ) //Owieczka
+  {
+    for ( x = ((CUWidth - 1) >> 1); x >= 0; x-- )
+    {
+      rpbCUSynthesied[2] &= (pAvail[x] != 0);
+    }
+    for ( x = CUWidth - 1; x >= ((CUWidth) >> 1); x-- )
+    {
+      rpbCUSynthesied[3] &= (pAvail[x] != 0);
+    }
+    pAvail += iStride;
+  }
+
+  //rpbCUSynthesied[0] = !rpbCUSynthesied[0];
+  //rpbCUSynthesied[1] = !rpbCUSynthesied[1];
+  //rpbCUSynthesied[2] = !rpbCUSynthesied[2];
+  //rpbCUSynthesied[3] = !rpbCUSynthesied[3];
+}
+#endif
Index: /branches/0.3-poznan-univ/source/Lib/TLibCommon/TComPic.h
===================================================================
--- /branches/0.3-poznan-univ/source/Lib/TLibCommon/TComPic.h	(revision 27)
+++ /branches/0.3-poznan-univ/source/Lib/TLibCommon/TComPic.h	(revision 28)
@@ -61,4 +61,16 @@
 
   TComPicYuv*           m_apcPicYuv[2];           //  Texture,  0:org / 1:rec
+
+#if POZNAN_AVAIL_MAP
+  TComPicYuv*           m_apcPicYuvAvail;         //  Availability Map - Does the given pixel can be synthesised in receiver
+#endif
+
+#if POZNAN_SYNTH_VIEW
+  TComPicYuv*           m_apcPicYuvSynth;         //  Sythesied image
+#endif
+#if POZNAN_TEXTURE_TU_DELTA_QP_ACCORDING_TO_DEPTH
+  TComPicYuv*           m_apcPicYuvSynthDepth;         //  Sythesied depth image
+#endif
+
 #if DEPTH_MAP_GENERATION
   TComPicYuv*           m_pcPredDepthMap;         //  estimated depth map
@@ -101,4 +113,9 @@
 #if HHI_INTERVIEW_SKIP
   TComPicYuv*           m_pcUsedPelsMap;
+#endif
+#if POZNAN_TEXTURE_TU_DELTA_QP_PARAM_IN_CFG_FOR_ENC 
+  Double                m_dTexDqpAccordingToDepthOffset;
+  Double                m_dTexDqpAccordingToDepthMul;
+  Int                   m_iTexDqpAccordingToDepthTopBottomRow; 
 #endif
 
@@ -129,4 +146,15 @@
   TComPicYuv*   getPicYuvOrg()        { return  m_apcPicYuv[0]; }
   TComPicYuv*   getPicYuvRec()        { return  m_apcPicYuv[1]; }
+
+#if POZNAN_AVAIL_MAP
+  TComPicYuv*   getPicYuvAvail()      { return  m_apcPicYuvAvail; } //Owieczka - returns available map from other pic image
+#endif
+
+#if POZNAN_SYNTH_VIEW
+  TComPicYuv*   getPicYuvSynth()      { return  m_apcPicYuvSynth; } //Owieczka - returns synth form other pic in image
+#endif
+#if POZNAN_TEXTURE_TU_DELTA_QP_ACCORDING_TO_DEPTH
+  TComPicYuv*   getPicYuvSynthDepth() { return  m_apcPicYuvSynthDepth; };    //  Sythesied depth image
+#endif
 
 #if DEPTH_MAP_GENERATION
@@ -203,4 +231,13 @@
 
   Void          addOriginalBuffer       ();
+#if POZNAN_AVAIL_MAP
+  Void          addAvailabilityBuffer   ();
+#endif
+#if POZNAN_SYNTH_VIEW
+  Void          addSynthesisBuffer      ();
+#endif
+#if POZNAN_TEXTURE_TU_DELTA_QP_ACCORDING_TO_DEPTH
+  Void          addSynthesisDepthBuffer ();
+#endif
 #if PARALLEL_MERGED_DEBLK
   Void          addDeblockBuffer        ();
@@ -221,4 +258,13 @@
 
   Void          removeOriginalBuffer    ();
+#if POZNAN_SYNTH_VIEW
+  Void          removeSynthesisBuffer   ();
+#endif
+#if POZNAN_TEXTURE_TU_DELTA_QP_ACCORDING_TO_DEPTH
+  Void          removeSynthesisDepthBuffer ();
+#endif
+#if POZNAN_AVAIL_MAP
+  Void          removeAvailabilityBuffer();
+#endif
 #if PARALLEL_MERGED_DEBLK
   Void          removeDeblockBuffer     ();
@@ -235,4 +281,8 @@
 #if HHI_INTERVIEW_SKIP
   Void          removeUsedPelsMapBuffer ();
+#endif
+
+#if POZNAN_AVAIL_MAP
+  Void          checkSynthesisAvailability(  TComDataCU*& rpcBestCU, UInt iCuAddr, UInt uiAbsZorderIdx, UInt uiPartDepth, Bool *&rpbCUSynthesied);
 #endif
 
@@ -254,4 +304,12 @@
   const SEImessages* getSEIs() const { return m_SEIs; }
 
+#if POZNAN_TEXTURE_TU_DELTA_QP_PARAM_IN_CFG_FOR_ENC 
+  Double getTexDqpAccordingToDepthOffset( )      { return m_dTexDqpAccordingToDepthOffset;}
+  Double getTexDqpAccordingToDepthMul( )         { return m_dTexDqpAccordingToDepthMul;}
+  Int    getTexDqpAccordingToDepthTopBottomRow( ){ return m_iTexDqpAccordingToDepthTopBottomRow;}
+  Void   setTexDqpAccordingToDepthOffset      ( Double dTexDqpAccordingToDepthOffset    ){ m_dTextureCuDeltaQpOffset       = dTexDqpAccordingToDepthOffset; }
+  Void   setTexDqpAccordingToDepthMul         ( Double dTexDqpAccordingToDepthMul       ){ m_dTexDqpAccordingToDepthMul          = dTexDqpAccordingToDepthMul; }
+  Void   setTexDqpAccordingToDepthTopBottomRow( Int iTexDqpAccordingToDepthTopBottomRow ){ m_iTexDqpAccordingToDepthTopBottomRow = iTexDqpAccordingToDepthTopBottomRow; }  
+#endif 
 };// END CLASS DEFINITION TComPic
 
Index: /branches/0.3-poznan-univ/source/Lib/TLibCommon/TComPicSym.h
===================================================================
--- /branches/0.3-poznan-univ/source/Lib/TLibCommon/TComPicSym.h	(revision 27)
+++ /branches/0.3-poznan-univ/source/Lib/TLibCommon/TComPicSym.h	(revision 28)
@@ -43,4 +43,8 @@
 
 // Include files
+#if POZNAN_MP
+#include "../TLibCommon/TComMP.h"
+#endif
+
 #include "CommonDef.h"
 #include "TComSlice.h"
Index: /branches/0.3-poznan-univ/source/Lib/TLibCommon/TComPicYuv.cpp
===================================================================
--- /branches/0.3-poznan-univ/source/Lib/TLibCommon/TComPicYuv.cpp	(revision 27)
+++ /branches/0.3-poznan-univ/source/Lib/TLibCommon/TComPicYuv.cpp	(revision 28)
@@ -8,4 +8,5 @@
 #include <assert.h>
 #include <memory.h>
+#include <math.h>
 
 #ifdef __APPLE__
@@ -455,2 +456,46 @@
   }
 }
+#if POZNAN_NONLINEAR_DEPTH
+Void TComPicYuv::nonlinearDepthForward(TComPicYuv *pcPicDst, Float p)
+{
+  Int		x,y;
+  TComNonlinearDepthForward cNonlinearDepthFwd(p, g_uiBitIncrement, g_uiBitIncrement);
+
+  // Luma
+  Pel* pPelSrc = getLumaAddr();
+  Pel* pPelDst = pcPicDst->getLumaAddr();
+  for(y=0; y<m_iPicHeight; y++)
+	{
+    for(x=0; x<m_iPicWidth; x++)
+    {
+      pPelDst[x] = (Pel)( cNonlinearDepthFwd(pPelSrc[x]) + 0.5);
+    }
+    pPelDst += pcPicDst->getStride();
+    pPelSrc += getStride();
+  }
+  // Chroma
+  copyToPicCb(pcPicDst);
+  copyToPicCr(pcPicDst);
+}
+Void TComPicYuv::nonlinearDepthBackward(TComPicYuv *pcPicDst, Float p)
+{
+  Int		x,y;
+  TComNonlinearDepthBackward cNonlinearDepthBwd(p, g_uiBitIncrement, g_uiBitIncrement);
+
+  // Luma
+  Pel* pPelSrc = getLumaAddr();
+  Pel* pPelDst = pcPicDst->getLumaAddr();
+  for(y=0; y<m_iPicHeight; y++)
+	{
+    for(x=0; x<m_iPicWidth; x++)
+    {
+      pPelDst[x] = (Pel)( cNonlinearDepthBwd(pPelSrc[x]) + 0.5);
+    }
+    pPelDst += pcPicDst->getStride();
+    pPelSrc += getStride();
+  }
+  // Chroma
+  copyToPicCb(pcPicDst);
+  copyToPicCr(pcPicDst);
+}
+#endif
Index: /branches/0.3-poznan-univ/source/Lib/TLibCommon/TComPicYuv.h
===================================================================
--- /branches/0.3-poznan-univ/source/Lib/TLibCommon/TComPicYuv.h	(revision 27)
+++ /branches/0.3-poznan-univ/source/Lib/TLibCommon/TComPicYuv.h	(revision 28)
@@ -44,4 +44,54 @@
 #include "CommonDef.h"
 
+#if POZNAN_NONLINEAR_DEPTH
+
+#include <math.h>
+
+class TComNonlinearDepthForward // OLGIERD - Z-NL-Power conversion
+{
+private:
+  Double m_fMul;
+  Float m_fPower;
+
+public:
+
+  TComNonlinearDepthForward(Float fPower, Int iInputBitIncrement, Int iOutputBitIncrement)
+  {
+    m_fPower = fPower;
+    Double fPostMul = (1<<(8+iOutputBitIncrement))-1; // OLGIERD ToDo - should be or not?
+    Double fPreMul  = 1.0/((1<<(8+iInputBitIncrement))-1);
+    m_fMul = fPostMul*pow(fPreMul,(Double)fPower);
+  };
+
+  inline Double operator() (Double Value)
+  {    
+    if (Value<0) return -pow( -Value,(Double)m_fPower)*m_fMul;
+    return pow(Value,(Double)m_fPower)*m_fMul;
+  };
+};
+
+class TComNonlinearDepthBackward // OLGIERD - Z-NL-Power conversion
+{
+private:
+  Double m_fMul;
+  Float m_fPower;
+
+public:
+
+  TComNonlinearDepthBackward(Float fPower, Int iInputBitIncrement, Int iOutputBitIncrement) 
+  {     
+    m_fPower = fPower = 1.0/fPower;
+    Double fPostMul = (1<<(8+iOutputBitIncrement))-1; // OLGIERD ToDo - should be or not?
+    Double fPreMul  = 1.0/((1<<(8+iInputBitIncrement))-1);
+    m_fMul = fPostMul*pow(fPreMul,(Double)fPower);
+  };
+
+  inline Double operator() (Double Value)
+  {    
+    if (Value<0) return -pow( -Value,(Double)m_fPower)*m_fMul;
+    return pow(Value,(Double)m_fPower)*m_fMul;
+  };
+};
+#endif
 // ====================================================================================================================
 // Class definition
@@ -175,4 +225,8 @@
   Void  setChromaTo  ( Pel pVal );  
 
+#if POZNAN_NONLINEAR_DEPTH
+  Void nonlinearDepthForward(TComPicYuv *pcPicDst, Float p);
+  Void nonlinearDepthBackward(TComPicYuv *pcPicDst, Float p);
+#endif
 };// END CLASS DEFINITION TComPicYuv
 
